#import "../CCNMediaTerm/CCNSMT/CCNSMT.tlb" no_namespace, raw_interfaces_only

int main()
{
	HRESULT hr;

	// Initialize COM
	hr = CoInitialize(NULL);

	// Get Interface ICCNMediaTerm from the WinRTP COM Object using smart pointer defined by the #import command above. 
	// Automatically calls IUnknown::AddRef();
	ICCNMediaTermPtr pICCNMediaTerm(__uuidof(CCNMediaTerm));

	// Initialize WinRTP. Must be the first call
	pICCNMediaTerm->Initialize();

	// Set parameters for receive side
	pICCNMediaTerm->SetAudioCodecRX(4, 20, 0, 0);
	pICCNMediaTerm->SetAudioReceivePort(8500);

	// Set parameters for transmit side
	pICCNMediaTerm->SetAudioCodecTX(4, 20, 0, 0, 0, 0);
	pICCNMediaTerm->SetAudioDestination(L"127.0.0.1", 8500);

	// Start reception side. we will use the default (-1) playback device
	pICCNMediaTerm->StartRX(-1);

	// Start transmit side. we will use the default (-1) recording device
	pICCNMediaTerm->StartTX(-1);

	// Set the speaker volume to 50%
	pICCNMediaTerm->SetSpeakerVolume(-1, 50);

	// Set the microphone volume to 50%
	pICCNMediaTerm->SetMicrophoneVolume(-1, 50);

	// Hear yourself for 5 seconds
	Sleep(5000);

	// Stop reception & transmission
	pICCNMediaTerm->StopRX();
	pICCNMediaTerm->StopTX();

	// Unitialize WinRTP. Must be the last call
	pICCNMediaTerm->UnInitialize();
	// Let go of the reference to the ICCNMediaTerm interface. Automatically calls IUnknown::Release()
	pICCNMediaTerm = 0;

	// Uninitialize COM
	CoUninitialize();

	return 0;
}